package com.liang.service;

import com.liang.entity.PrjAnnualbudget;
import com.liang.entity.PrjProject;
import com.liang.entity.StaBudgetapproval;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.List;
import java.util.Map;

/**
 * 年度预算(PrjAnnualbudget)表服务接口
 *
 * @author makejava
 * @since 2023-05-17 08:56:50
 */
public interface PrjAnnualbudgetService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjAnnualbudget queryById(Integer id);

    /**
     * 通过任务书ID查询单条数据
     *
     * @param rws
     * @return
     */
    PrjAnnualbudget queryByRws(Integer rws);

    /**
     * 查询单条数据
     *
     * @param map
     * @return
     */
    PrjAnnualbudget getAnnualBudget(Map map);

    /**
     * 分页查询
     *
     * @param prjAnnualbudget 筛选条件
     * @param pageRequest     分页对象
     * @return 查询结果
     */
    Page<PrjAnnualbudget> queryByPage(PrjAnnualbudget prjAnnualbudget, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param prjAnnualbudget 实例对象
     * @return 实例对象
     */
    int insert(PrjAnnualbudget prjAnnualbudget);

    /**
     * 撤销数据（基本信息）
     *
     * @param prjAnnualbudget 实例对象
     * @return 影响行数
     */
    int tjrevokeApprove(PrjAnnualbudget prjAnnualbudget);

    /**
     * 修改数据
     *
     * @param prjAnnualbudget 实例对象
     * @return 实例对象
     */
    int update(PrjAnnualbudget prjAnnualbudget);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    /**
     * 获取年度预算列表
     *
     * @return
     */
    List<PrjAnnualbudget> getNdysList(Map map);

    /**
     * 获取年份列表
     *
     * @return
     */
    List<String> getYearList();

    /**
     * 批量删除年度预算
     *
     * @param idList
     * @return
     */
    int batchDelete(List<Integer> idList);

    /**
     * 修改审批状态
     *
     * @param annualbudget 实例对象
     * @return 实例对象
     */
    int updateSpzt(PrjAnnualbudget annualbudget);

    void updateSJYZXAndXTJSYZX(Integer rws);

    PrjAnnualbudget queryByRws1(Integer rws, Integer nf);

    void updateSFXG(Integer xmid);
}
